%define name owncloud
%define version 5.0.3
%define release 1.beta7
%define httpuser apache

%if %{?fedora}%{?rhel} >= 5
%global useselinux 1
%else
%global useselinux 0
%endif

Summary: Your Cloud, Your Data, Your Way!
Name: %{name}
Version: %{version}
Release: %{release}%{?dist}
Distribution: RHEL
License: GNU GPL
URL: http://owncloud.org
Group: application/internet
Source: %{name}-%{version}.tar.bz2
Source1: httpd.conf
Source2: logrotate.conf
Source3: owncloud.conf

Patch0: owncloud-5.0.3-auth_remote_user.patch
Patch1: owncloud-5.0.3-username_as_uid_not_uuid.patch

Packager: Daniel B. <daniel@firewall-services.com>
BuildArch: noarch
BuildRoot: /var/tmp/%{name}-%{version}

Requires: php-gd
Requires: httpd
Requires: logrotate

%description
ownCloud gives you universal access to your files through a web interface or WebDAV.
It also provides a platform to easily view & sync your contacts, calendars and
bookmarks across all your devices and enables basic editing right on the web.
Installation has minimal server requirements, doesn’t need special
permissions and is quick. ownCloud is extendable via a simple but powerful
API for applications and plugins.

%prep
%setup -n %{name}
%patch0 -p1
%patch1 -p1

%build
# empty build

%install

%{__rm} -rf %{buildroot}
%{__mkdir} -p %{buildroot}/%{_datadir}/%{name}
for a in $(find ./ -mindepth 1 -maxdepth 1 -type d -print); do
    cp -r $a %{buildroot}/%{_datadir}/%{name}/
done
cp {*.php,*.xml,.htaccess} %{buildroot}/%{_datadir}/%{name}/

# Create the data dir
%{__mkdir} -p %{buildroot}/%{_localstatedir}/lib/%{name}/{data,apps,tmp,sessions}

# owncloud conf
%{__mkdir} -p %{buildroot}/%{_sysconfdir}/%{name}/
mv %{buildroot}/%{_datadir}/%{name}/config/* %{buildroot}/%{_sysconfdir}/%{name}/
%{__rm} -rf %{buildroot}/%{_datadir}/%{name}/config/
sed -e "s|__LOG_FILE__|%{_localstatedir}/log/%{name}.log|g" \
    -e "s|__ROOT_DIR__|%{_datadir}/%{name}|g" \
    -e "s|__DATA_DIR__|%{_localstatedir}/lib/%{name}|g" \
     %{SOURCE3} > %{buildroot}/%{_sysconfdir}/%{name}/config.php
%{__ln_s} %{_sysconfdir}/%{name}/ %{buildroot}/%{_datadir}/%{name}/config

# Log
%{__mkdir} -p %{buildroot}/%{_localstatedir}/log/
touch %{buildroot}/%{_localstatedir}/log/%{name}.log
%{__mkdir} -p %{buildroot}/%{_sysconfdir}/logrotate.d/
%{__install} -m 644 %{SOURCE2} %{buildroot}/%{_sysconfdir}/logrotate.d/%{name}
sed  -e "s|__LOG_DIR__|%{_localstatedir}/log/%{name}.log|g" \
     -e "s|__APACHE__|%{httpuser}|g" \
     %{SOURCE2} > %{buildroot}/%{_sysconfdir}/logrotate.d/%{name}

# Apache conf
%{__mkdir} -p %{buildroot}/%{_sysconfdir}/httpd/conf.d/
%{__install} -m 0644 %{SOURCE1} %{buildroot}/%{_sysconfdir}/httpd/conf.d/%{name}.conf
sed -i -e "s|__ROOT_DIR__|%{_datadir}/%{name}|g" \
       -e "s|__DATA_DIR__|%{_localstatedir}/lib/%{name}/|g" \
       -e "s|__LOG_FILE__|%{_localstatedir}/log/%{name}.log|g" \
       -e "s|__CONF_DIR__|%{_sysconfdir}/%{name}|g" \
       %{buildroot}/%{_sysconfdir}/httpd/conf.d/%{name}.conf

%clean
rm -rf %{buildroot}

%post
%if %{useselinux}
(
# New File context
semanage fcontext -a -s system_u -t httpd_log_t           -r s0 "%{_localstatedir}/log/%{name}.log"
semanage fcontext -a -s system_u -t httpd_sys_script_rw_t -r s0 "%{_localstatedir}/lib/%{name}(/.*)?"
semanage fcontext -a -s system_u -t httpd_sys_script_rw_t -r s0 "%{_sysconfdir}/%{name}(/.*)?"
# files created by app
restorecon -R %{_datadir}/%{name}/
restorecon -R %{_localstatedir}/lib/%{name}
restorecon -R %{_localstatedir}/log/%{name}.log
restorecon -R %{_sysconfdir}/%{name}
) &>/dev/null || :
%endif

%postun
%if %{useselinux}
if [ "$1" -eq "0" ]; then
    # Remove the File Context
    (
    semanage fcontext -d "%{_localstatedir}/lib/%{name}(/.*)?"
    semanage fcontext -d "%{_localstatedir}/log/%{name}.log"
    semanage fcontext -d "%{_sysconfdir}/%{name}(/.*)?"
    ) &>/dev/null || :
fi
%endif

%files
%defattr(-,root,root)
%doc AUTHORS COPYING-AGPL COPYING-README README
%{_datadir}/%{name}
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/lib/%{name}/data
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/lib/%{name}/apps
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/lib/%{name}/tmp
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/lib/%{name}/sessions
%attr(660,root,%{httpuser}) %{_localstatedir}/log/%{name}.log
%dir %attr(770,root,%{httpuser}) %{_sysconfdir}/%{name}/
%{_sysconfdir}/%{name}/
%config(noreplace) %attr(660,root,%{httpuser}) %{_sysconfdir}/%{name}/config.php
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}

%changelog
* Sun Apr 7 2013 Daniel B. <daniel@firewall-services.com> - 5.0.3-1
- update to 5.0.3

* Fri Nov 30 2012 Daniel B. <daniel@firewall-services.com> - 4.5.3-1
- Initial package


